FUNCTION f1 RETURNS INT
    (INPUT l  AS LONGCHAR,
     INPUT ch AS CHARACTER,
     INPUT i  AS INT,
     INPUT j  AS INT64).
   l  = "long-char".
   ch = "char-acter".
   i  = 300.
   j  = 5000000000.
END.

FUNCTION f2 RETURNS INT
    (OUTPUT l  AS LONGCHAR,
     OUTPUT ch AS CHARACTER,
     OUTPUT i  AS INT,
     OUTPUT j  AS INT64).
   l  = "long-char".
   ch = "char-acter".
   i  = 200.
   j  = 400000000 + 0.
END.

FUNCTION f3 RETURNS INT
    (INPUT-OUTPUT l  AS LONGCHAR,
     INPUT-OUTPUT ch AS CHARACTER,
     INPUT-OUTPUT i  AS INT,
     INPUT-OUTPUT j  AS INT64).
   l  = "long-char".
   ch = "char-acter".
   i  = 100.
   j  = 3000000000.
END.

DEFINE VAR l  AS LONGCHAR.
DEFINE VAR ch AS CHARACTER.
DEFINE VAR i  AS INT.
DEFINE VAR j  AS INT64.

DISPLAY SKIP "f1 static".
DISPLAY f1(l,  ch, i, j).
DISPLAY f1(l,   l, i, i).
DISPLAY f1(ch,  l, j, i).
DISPLAY f1(ch, ch, j, j).

DISPLAY SKIP "f2 static".
DISPLAY f2(l,  ch, i, j).
DISPLAY f2(l,   l, i, i).
DISPLAY f2(ch,  l, j, i).
DISPLAY f2(ch, ch, j, j).

DISPLAY SKIP "f3 static".
DISPLAY f3(l,  ch, i, j).
DISPLAY f3(l,   l, i, i).
DISPLAY f3(ch,  l, j, i).
DISPLAY f3(ch, ch, j, j).

DISPLAY SKIP "f1 dynamic".
DISPLAY DYNAMIC-FUNCTION("f1", l, ch,  i, j).
DISPLAY DYNAMIC-FUNCTION("f1", l,  l,  i, i).
DISPLAY DYNAMIC-FUNCTION("f1", ch, l,  j, i).
DISPLAY DYNAMIC-FUNCTION("f1", ch, ch, j, j).

DISPLAY SKIP "f2 dynamic".
DISPLAY DYNAMIC-FUNCTION("f2",  l, ch, i, j).
DISPLAY DYNAMIC-FUNCTION("f2",  l,  l, i, i).
DISPLAY DYNAMIC-FUNCTION("f2", ch,  l, j, i).
DISPLAY DYNAMIC-FUNCTION("f2", ch, ch, j, j).

DISPLAY SKIP "f3 dynamic".
DISPLAY DYNAMIC-FUNCTION("f3",  l, ch, i, j).
DISPLAY DYNAMIC-FUNCTION("f3",  l,  l, i, i).
DISPLAY DYNAMIC-FUNCTION("f3", ch,  l, j, i).
DISPLAY DYNAMIC-FUNCTION("f3", ch, ch, j, j).
