DISPLAY "Bit set/get tests" SKIP WITH NO-LABELS.

DEF VAR src  AS INT   NO-UNDO INIT 139. /*  10001011*/
DEF VAR dest AS INT   NO-UNDO INIT 513. /*1000000001*/

DEFINE VARIABLE nul AS INT64.
nul = ?.


/* src = GET-BITS(dest, nul, 1) NO-ERROR.
DISPLAY src + 0.
PAUSE.

src = GET-BITS(dest, nul, 1).
DISPLAY src + 0.
PAUSE.

QUIT. */

PUT-BITS(dest, 4, 4) = src.             /*1001011001*/
DISPLAY "PUT-BITS(513, 4, 4) = 139 --> " dest + 0 SKIP. /* should be 601 */
dest = 513.
PUT-BITS(dest, 2, 4) = src.             /*1000010111*/
DISPLAY "PUT-BITS(513, 2, 4) = 139 --> " dest + 0 SKIP. /* should be 535 */

dest = 601. /*1001011001*/
DISPLAY "GET-BYTES(601, 1, 4) = " GET-BITS(dest, 1, 4) SKIP. /* should be  9 */
DISPLAY "GET-BYTES(601, 2, 4) = " GET-BITS(dest, 2, 4) SKIP. /* should be 12 */
DISPLAY "GET-BYTES(601, 4, 4) = " GET-BITS(dest, 4, 4) SKIP. /* should be 11 */
dest = 535. /*1000010111*/
DISPLAY "GET-BYTES(535, 1, 4) = " GET-BITS(dest, 1, 4) SKIP. /* should be  7 */
DISPLAY "GET-BYTES(535, 2, 4) = " GET-BITS(dest, 2, 4) SKIP. /* should be 11 */
DISPLAY "GET-BYTES(535, 4, 4) = " GET-BITS(dest, 4, 4) SKIP. /* should be  2 */


/* ****************************************************************************  */

DEF VAR dest2 AS INT64 NO-UNDO FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" INIT 1234567890123456789.
DEF VAR src2  AS INT64 NO-UNDO FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" INIT 513.
DISPLAY "dest2=" dest2 SKIP "src2 =" src2 SKIP.

dest2 = 1234567890123456789.
PUT-BITS(dest2, 2, 10) = src2.
DISPLAY "PUT-BITS(dest2,  2, 10) = src2 --> " dest2 + 0 FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 1234567890123457539 */
dest2 = 1234567890123456789.
PUT-BITS(dest2, 4, 10) = src2.
DISPLAY "PUT-BITS(dest2,  4, 10) = src2 --> " dest2 + 0 FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 1234567890123460621 */
dest2 = 1234567890123456789.
PUT-BITS(dest2, 20, 10) = src2.
DISPLAY "PUT-BITS(dest2, 20, 10) = src2 --> " dest2 + 0 FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 1234567889890672917 */
dest2 = 1234567890123456789.
PUT-BITS(dest2, 40, 10) = src2.
DISPLAY "PUT-BITS(dest2, 40, 10) = src2 --> " dest2 + 0 FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 1234831772914123029 */

dest2 = 1234567890123456781.
DISPLAY "GET-BITS(dest2,  1, 10) = " GET-BITS(dest2,  1, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 269 */
DISPLAY "GET-BITS(dest2,  2, 10) = " GET-BITS(dest2,  2, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 134 */
DISPLAY "GET-BITS(dest2,  4, 10) = " GET-BITS(dest2,  4, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be  33 */
DISPLAY "GET-BITS(dest2, 20, 10) = " GET-BITS(dest2, 20, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 957 */
DISPLAY "GET-BITS(dest2, 40, 10) = " GET-BITS(dest2, 40, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be  33 */
dest2 = 1234567890123456771.
DISPLAY "GET-BITS(dest2,  1, 10) = " GET-BITS(dest2,  1, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 259 */
DISPLAY "GET-BITS(dest2,  2, 10) = " GET-BITS(dest2,  2, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 129 */
DISPLAY "GET-BITS(dest2,  4, 10) = " GET-BITS(dest2,  4, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be  32 */
DISPLAY "GET-BITS(dest2, 20, 10) = " GET-BITS(dest2, 20, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be 957 */
DISPLAY "GET-BITS(dest2, 40, 10) = " GET-BITS(dest2, 40, 10) FORMAT ">>>,>>>,>>>,>>>,>>>,>>>,>>9" SKIP. /* should be  33 */

